#include <iostream>

using namespace std;

int a[100000];
int izbacivanja[100000];

void calc(int n) {
    cin>>a[0];
    izbacivanja[0] = 0;
    if(n == 1) return;
    int l = -1, r = 0;
    for(int i = 1; i < n; i++) {
        cin>>a[i];
        izbacivanja[i] = izbacivanja[i - 1];
        if(a[i] >= a[r]) {
            l = r;
            r = i;
        }
        else {
            izbacivanja[i]++;
            if(l == -1 || a[i] >= a[l]) {
                r = i;
            }
        }
    }
}

int main()
{
    int n, q, l, r;
    cin>>n;
    calc(n);
    cin>>q;
    for(int i = 0; i < q; i++) {
        cin>>l>>r;
        if(izbacivanja[r - 1] - izbacivanja[l - 1] <= 1) cout<<"DA"<<endl;
        else cout<<"NE"<<endl;
    }
    return 0;
}